=== debian/changelog ===
simgrid (3.34-3) unstable; urgency=medium

  * Integrate an upstream patch to fix the execution with ns3 v3.36+
    (Closes: #1042217).

 -- Martin Quinson <mquinson@debian.org>  Tue, 07 Nov 2023 13:58:45 +0100

simgrid (3.34-2) unstable; urgency=medium

  * d/control: Add 'Rules-Requires-Root: no' as it should be.

 -- Martin Quinson <mquinson@debian.org>  Tue, 18 Jul 2023 16:00:30 +0200

simgrid (3.34-1) unstable; urgency=medium

  * d/control: Also drop lua from the Recommends:
  * New upstream release: 3.34 (3.33 never got released upstream)
    - Maint: MSG and Java are gone (EOL was scheduled for 2020), move
             to C++17, and drop 32bits support.
    - Model: Introduce a fluid I/O model, mixing I/O and network, to
             represent streaming from disk
    - API: DAG/workflow loader; Introducing Tasks which are
           activities that can be fired several times.
    - Doc: Several new documentation sections, and a new tutorial on DAGs.
    - MC: Safety properties now portable to every OS, activated by default
          in all builds (in particular in the Debian package).
    - MC: Introduction ODPOR/SDPOR reductions and guiding strategies
          (better state space traversal).
    - (+ internal refactoring, bug fixes and documentation improvement)
  * d/control: bump Standards-version to 4.6.2.
  * d/control: Java was dropped upstream, so kill the relevant package.
  * d/p: All our patches are integrated or obsoleted by upstream.
  * simgrid-colorizer is not built upstream anymore.

 -- Martin Quinson <mquinson@debian.org>  Tue, 27 Jun 2023 00:56:28 +0200

simgrid (3.32-3) UNRELEASED; urgency=medium

  * Trim trailing whitespace.
  * Update standards version to 4.6.1, no changes needed.

 -- Debian Janitor <janitor@jelmer.uk>  Wed, 19 Oct 2022 21:28:30 -0000
